<?php

class bettel{
	private $db;
	private $session = array();
	private $config;
	private $uid = 0;
	private $error = 0;
	private $meldung = '';
	private $cookie = 0;
	private $ip;
	private $refferer;
	
	function __construct(){
		global $_SESSION,$datenbank,$grundconfig,$_SERVER;
		$this->db = $datenbank;
		$this->session = $this->db->escape($_SESSION);
		$this->config = $grundconfig;
		$this->ip = $_SERVER['REMOTE_ADDR'];
		if(isset($_SERVER['HTTP_REFERER'])){
			$this->refferer = $this->db->escape($_SERVER['HTTP_REFERER']);
		}else{
			$this->refferer = 'direktaufruf';
		}
	}
	
	public function Top25(){
		$aus = '';
		$rang = 1;
		$result = $this->db->get_results('SELECT k.uid, k.angebettelt, k.bv, u.nickname FROM ' . PREFIX . KONTO . ' k LEFT JOIN ' . PREFIX . USER . ' u ON u.uid = k.uid WHERE k.angebettelt > 0 ORDER BY angebettelt DESC LIMIT 25');
		foreach($result AS $res){
			$aus .= '
				<tr>
					<td>' . $rang++ . '.&nbsp;</td>
					<td>&nbsp;' . $res->nickname . '</td>
					<td align="right">' . number_format($res->angebettelt, 0) . '&nbsp;</td>
					<td align="right">' . number_format($res->bv, 2, ',', '.') . ' ' . $this->config->waehrung . '&nbsp;</td>
				</tr>
			';
		}
		return $aus;
	}
	
	private function AngebetteltPruef(){
		if($this->session['uid'] == $this->uid || $this->uid == $this->cookie){
			$this->error = 1;
			$this->meldung = BETTEL_SELF_TRUE;
		}
	}
	
	private function ReloadCheck(){
		if($this->db->num_rows("SELECT bis FROM " . PREFIX . RELOAD . " WHERE ip = '$this->ip' and tan = 'bettelaufruf' and bis >= " . time() . " LIMIT 1") == 1){
			$this->error = 1;
			$this->meldung = BETTEL_RELOAD_TRUE;
		}
	}
	
	private function BettelSperre(){
		if($this->db->num_rows("SELECT uid FROM ". PREFIX . KONTO ." WHERE uid = '$this->uid' AND bettel_sperre = '1' ") != 0){
			$this->error = 1;
			$this->meldung = BETTEL_SPERRE_TRUE;
		}
	}
	
	private function BettelAuszahlung(){
		global $_SERVER;
		$bettelsumme = rand($this->config->min_betteln * 100, $this->config->max_betteln * 100) / 100;
		$new_reload = time() + $this->config->reload_betteln;
		$bettelb = array(
			"uid" => $this->uid,
			"refferer" => $_SERVER['HTTP_REFERER'],
			"betrag" => $bettelsumme,
			"zeit" => time()
		);
		$this->db->insert(PREFIX . BETTELB, $bettelb,1);
		$this->db->insert(PREFIX . RELOAD, array("ip" => $this->ip,"uid" => $this->uid ,"tan" => 'bettelaufruf',"bis" => $new_reload) );
		$this->db->query("UPDATE ". PREFIX . KONTO ." SET angebettelt = angebettelt + 1, bv = bv + $bettelsumme, kontostand_a = kontostand_a + $bettelsumme WHERE uid = '$this->uid' ");
		$this->db->update(PREFIX . BETTELB, array("zeit" => time(),"betrag" => $bettelsumme,"refferer" => $this->refferer,"uid" => $this->uid));
		$bilanz = Classloader('bilanz');
		
		refumsatz ($bettelsumme, $this->uid);
		rallysystem ($this->uid, '6', $bettelsumme);
		$bilanz->bilanz(0,$bettelsumme,'werbekosten','Bettellink');
		$this->meldung = '<b>Du hast für den User ' . $this->uid . ' gerade ' . $bettelsumme . ' ' . $this->config->waehrung . ' erbettelt!</b>';
	}
	
	public function BettelAufruf($get,$cookie){
		if(isset($cookie['uid'])){
			if(is_numeric($cookie['uid'])){$this->cookie = $cookie['uid'];}
		}
		if(is_numeric($get['ref'])){ $this->uid = $get['ref'];}
		if($this->config->reload_betteln > 0){
			$this->AngebetteltPruef();
			if($this->error == 0){ $this->ReloadCheck();}
			if($this->error == 0){ $this->BettelSperre();}
			if($this->error == 0){ $this->BettelAuszahlung();}
		}else{
			$this->error = 1;
			$this->meldung = BETTEL_NOT_ACTIVE;
		}
		
		return $aus = array("error" => $this->error, "meldung" => $this->meldung);
	}
}
?>
